/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the FindConversationsSegments200ResponseInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FindConversationsSegments200ResponseInner{}

// FindConversationsSegments200ResponseInner struct for FindConversationsSegments200ResponseInner
type FindConversationsSegments200ResponseInner struct {
	Id string `json:"id"`
	Segments []string `json:"segments"`
}

// NewFindConversationsSegments200ResponseInner instantiates a new FindConversationsSegments200ResponseInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFindConversationsSegments200ResponseInner(id string, segments []string) *FindConversationsSegments200ResponseInner {
	this := FindConversationsSegments200ResponseInner{}
	this.Id = id
	this.Segments = segments
	return &this
}

// NewFindConversationsSegments200ResponseInnerWithDefaults instantiates a new FindConversationsSegments200ResponseInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFindConversationsSegments200ResponseInnerWithDefaults() *FindConversationsSegments200ResponseInner {
	this := FindConversationsSegments200ResponseInner{}
	return &this
}

// GetId returns the Id field value
func (o *FindConversationsSegments200ResponseInner) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *FindConversationsSegments200ResponseInner) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *FindConversationsSegments200ResponseInner) SetId(v string) {
	o.Id = v
}

// GetSegments returns the Segments field value
func (o *FindConversationsSegments200ResponseInner) GetSegments() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Segments
}

// GetSegmentsOk returns a tuple with the Segments field value
// and a boolean to check if the value has been set.
func (o *FindConversationsSegments200ResponseInner) GetSegmentsOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Segments, true
}

// SetSegments sets field value
func (o *FindConversationsSegments200ResponseInner) SetSegments(v []string) {
	o.Segments = v
}

func (o FindConversationsSegments200ResponseInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FindConversationsSegments200ResponseInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["segments"] = o.Segments
	return toSerialize, nil
}

type NullableFindConversationsSegments200ResponseInner struct {
	value *FindConversationsSegments200ResponseInner
	isSet bool
}

func (v NullableFindConversationsSegments200ResponseInner) Get() *FindConversationsSegments200ResponseInner {
	return v.value
}

func (v *NullableFindConversationsSegments200ResponseInner) Set(val *FindConversationsSegments200ResponseInner) {
	v.value = val
	v.isSet = true
}

func (v NullableFindConversationsSegments200ResponseInner) IsSet() bool {
	return v.isSet
}

func (v *NullableFindConversationsSegments200ResponseInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFindConversationsSegments200ResponseInner(val *FindConversationsSegments200ResponseInner) *NullableFindConversationsSegments200ResponseInner {
	return &NullableFindConversationsSegments200ResponseInner{value: val, isSet: true}
}

func (v NullableFindConversationsSegments200ResponseInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFindConversationsSegments200ResponseInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


